#include <iostream>

using namespace std;

long long st(int q, int w)
{
    long long p=1;
    for(int i=0;i<w;i++)
    {
        p = (p * (q%998244353)) % 998244353;
    }
    return p;
}

int main()
{
    int n,m;
    cin >> n,m;
    int b[100005];
    for(int i=0;i<m;i++) cin >> b[i];
    int c;
    cin >> c;
    int a[500005];
    for(int i=0;i<n;i++) a[i]=i;
    for(int i=0;i<=n-m;i++)
    {
        for (int j=1; j<=m; j++)
        {
            a[i + b[j]] = a[i + j]
        }
    }
    int s=0;
    for(int i=0;i<n;i++) s+= (st(c,i)*a[i]);
}